########################################################
########## A. Podstawy programowania * * * ##############
########################################################

# Instrukcje warunkowe - funkcja if
# Klasyczna skladnia
if (warunek logiczny) {
  blok instrukcji
}

# Przyklad
a<-5
if (a<5) {
  "mniej niz 5"
}

# lub
if (warunek logiczny) {
  blok instrukcji 1
} else {
  blok instrukcji 2
}

# Przykład
if (a<5) {
  "mniej niz 5"
} else {
  "wiecej niz 5"
}

# Składnia uproszczona
ifelse(warunek logiczny, instrukcja 1, instrukcja 2)

# Przykład
a=1
ifelse(a<5,"mniej niz 5","wiecej niz 5")

# Jezeli warunek logiczny jest spelniony (wartosc logiczna - TRUE) to wykonany zostanie pierwszy blok instrukcji
# Jezeli warunek logiczny nie jest spelniony (wartosc logiczna - FALSE) to wykonany zostanie drugi blok instrukcji

### Zadanie
# 1. Napisz funkcję, która sprawdza czy liczba jest parzysta i zwraca taka informacje (parzysta, nieparzysta)
# Podpowiedz: Aby uzyskac reszte z dzielenia uzyj operatora modulo "%%" zamiast "/"

# Pętla for
for (iterator in kolekcja) {
  instrukcje
}

# Przyklad 1
# Wyświetla wszystkie elementy wektora dodajac do nich 10
wektor<-c(1:10)
for (i in wektor) {
  b=i+10
  print(b)
}

# 2. Ile jest liczb nieparzystych w wektorze x?
x <- c(2,5,3,9,8,11,6,4,5,6,7,2,3,4,6,4,7,5,3,4,6,7,3,4,6)

# Utwórz nową zmienną count i przypisz do niej wartość zero

# Sprawdź każdy element wektora i dodaj jeden do wartosci zmiennej count jezeli trafisz na liczbe nieparzysta

# 3*. Zadanie dodatkowe - oblicz zawartosc par GC w czasteczce DNA majac do dyspozycji sekwencje nici matrycowej
#Umiesc caly kod w obrębie funkcji dla ktorej jedynym argumentem bedzie poniższa sekwencja (seq)

seq<-c("A","A","T","C","C","A","A","G","G","C","C","C","A","T","A","G","A","T","G","A","C","A","T","A")

#####################################################################
########## B. Modele wzrostu populacji z czasem dyskretnym ###########
#####################################################################
# Modele z czasem dyskretnym mają postać rownania rożnicowego

####### * * * Ciag fibonacciego * * * ########
# Zadanie 1 - napisz funkcje ktora wyznacza 50 kolejnych wartosci w ciagu fibonacciego

#Etapy:
#A. Liczbe wyrazów ciagu zapisz pod zmienna N

#B. Utworz wektor z N wartosciami NA do ktorego bedziemy zapisywali wyniki, zapisz wektor pod zmienna fib

#C. Uzupelnij pierwsze dwa wyrazy ciagu fibonacciego: 1, 1, ... w wektorze fib

#D. Pod kolejne elementy wektora (od 3) podstaw kolejne wyrazy ciagu fibonacciego wedlug wzoru rekurencyjnego
#   Podpowiedz: Wykorzystaj petle for

#E. Narysuj wykres dla kolejnych wartosci ciagu fibonacciego (funkcja plot())


#Zadanie 2* - zadanie dodatkowe - Oszacuj ile wynosi liczba zlotego podzialu

################################################
####### * * * Wzrost geometryczny * * * ########
################################################

# 1. Stworz funkcje, ktora wylicza stan populacji w kolejnych krokach czasowych w oparciu o model geometryczny
# Przyjmij poczatkowa liczebnosc populacji rowna 10

# 2. Wygeneruj trzy wykresy w zaleznosci od wartosci parametru lambda (0.8, 1.3, 2.4)
#A. lambda <-0.5
#B. lambda <-1.5
#C. lambda <-2.5

# Podpowiedzi:
# Wyniki zapisz do wektora malt_geom
# Użyj funkcji for dla kolejnych krokow czasowych

# Trzy wykresy obok siebie
par(mfrow=c(1,3))

# Restart ustawień wykresów
dev.off()

# Przyklad wykresu:
plot(wynik, type="o", col="green") #wykres dla wektora "wynik", typ o, kolor zielony
title(main="Wzrost geometryczny, r=0.8", col.main="black", font.main=4, xlab="czas") #opis osi wykresu i wielkosc czcionki

#A. populacja - lambda=0.8

#B. populacja - lambda=1.4

#C. populacja - lambda=2.4

# 3. Pytania:
#3A. Jak zmienia sie liczebnosc populacji w zależnosci od wartosci parametru lambda?

#3B. Jaka jest maksymalna liczebnosc populacji wedlug tego modelu? Jak dlugo populacja rozwija sie?

#3C. Kiedy zastosowanie modelu z czasem dyskretnym jest uzasadnione? 

# Zadanie
# Utworz dwa wykresy obok siebie w ktorych na osi x znajduje sie czas a na osi y:
# 1. Liczebnosci populacji z punktu C
# 2. Zlogarytmowane liczebnosci z punktu C
# Pytanie: Co daje przedstawienie rownania wykladniczego na wspolrzednych pollogarytmicznych?

##############################################################################
########## * * * Modele wzrostu populacji z czasem ciągłym * * * #############
##############################################################################

#Rownania różniczkowe
#Zainstaluj i wczytaj pakiet deSolve - do rozwiązywania równań różniczkowych
install.packages("deSolve")
library(deSolve)

#######################################################
########## * * * Wzrost wykładniczy * * * #############
#######################################################

# Przykład modelu opartego na równaniu różniczkowym zwyczajnym
# Parametry modelu
r=0.5

# Warunek początkowy - początkowe zagęszczenie populacji (N0)
yini <- 10

# Tworzymy funkcje derivs (nazwa dowolna) z nastepującymi argumentami (zawsze te same!):
# t - wektor z krokami czasowymi dla ktorych rozwiązujemy równanie numerycznie
# y - zmienna zależna
# parms - wektor parametrów

derivs <- function(t, y, parms) {
  list(r * y) #Wlaściwy model
}

# Utworz wektor czas z liczbami od 0 do 20, co 0.1
czas <- seq(from = 0, to = 3, by = 0.1)

# Rozwiazywanie równań rożniczkowych, funkcja ode (ang. ordinary differential equations)
# times - wektor z krokami czasowymi dla ktorych rozwiązujemy równanie numerycznie
# func - nazwa funkcji opisujacej rownanie rózniczkowe, tutaj derivs
# parms - wartosci parametrow, ustawiamy na NULL (deklarujemy je osobno jak w tym przykladzie)
# method - metoda rozwiązywanie równań różniczkowych
?ode
out <- ode(y = yini, times = czas, func = derivs, method = euler,
           parms = NULL)

# Wynikiem jest macierz złożona z dwóch kolumn:
# 1. czas
# 2. oszacowane wartości zmiennej zależnej według modelu, tutaj zagęszczenie populacji
plot(out, main = "wzrost wykładniczy", lwd = 2)

########################
##### Zadania ##########
########################

# 1. Rozwiąż równanie rożniczkowe dla r=0.5, 0.9 oraz 1.5, warunek początkowy yini=10
# Rozwiązania pokaż na jednym wykresie

# 2 Wprowadz do R wzor ogólny
#A. Oblicz r zakładając, że populacja poczatkowa składa się z jednej komórki i podwaja swoją liczebność co 3 godziny

#B. Jaka będzie liczebność kolonii po 51 godzinach?

#C. Od jakiej liczebności kolonii bakterii należy zacząć aby otrzymać 81920 po 42 godzinach?

#D. Ilu godzin (h) potrzeba aby z 6 otrzymać 12288 komórek, zachowując stałe tempo podziałów?

###########################################################
####### * * * Model wzrostu logistycznego * * * ###########
###########################################################

# 1.Zadeklaruj parametry: r=1; K=10

# 2.Utwórz funkcję dla modelu wzrostu logistycznego

# A.Utworz wektor czas, od 0 do 30, co 0.2

# B.Rozwiąż rownanie rożniczkowe dla warunku poczatkowego yini=2

# C.Rozwiąż rówananie jeszcze raz dla innego warunku początkowego, yini = 16

# D.Narysuj wykres dla modelu logistycznego z rozwiązaniami z zadania 2A i 2B

# 3.Na podstawie wartości pochodnej odpowiedz na ponizsze pytania
# A.Jakie jest maksymalne zagęszczenie populacji według tego modelu? Jak dlugo populacja rozwija sie?

# B.W jakich warunkach obserwowalibyśmy spadek zageszczenia populacji? 



